from subprocess import Popen, PIPE
from time import sleep
from datetime import datetime
import RPi.GPIO as GPIO
import board
import digitalio
import adafruit_character_lcd.character_lcd as characterlcd

# Ändern Sie dies, wenn Sie ein LCD in einer anderen Größe haben.
lcd_columns = 16
lcd_rows = 2

lcd_rs = digitalio.DigitalInOut(board.D22)
lcd_en = digitalio.DigitalInOut(board.D17)
lcd_d4 = digitalio.DigitalInOut(board.D25)
lcd_d5 = digitalio.DigitalInOut(board.D24)
lcd_d6 = digitalio.DigitalInOut(board.D23)
lcd_d7 = digitalio.DigitalInOut(board.D18)


# Initialisierung des LCD
lcd = characterlcd.Character_LCD_Mono(lcd_rs, lcd_en, lcd_d4, lcd_d5, lcd_d6,
                                      lcd_d7, lcd_columns, lcd_rows)

# Suche nach einem aktiven Ethernet- oder WiFi-Gerät
def find_interface():
    find_device = "ip addr show"
    interface_parse = run_cmd(find_device)
    for line in interface_parse.splitlines():
        if "state UP" in line:
            dev_name = line.split(':')[1]
    return dev_name

# finde eine aktive IP auf dem ersten lebendigen Netzwerkgerät
def parse_ip():
    find_ip = "ip addr show %s" % interface
    find_ip = "ip addr show %s" % interface
    ip_parse = run_cmd(find_ip)
    for line in ip_parse.splitlines():
        if "inet " in line:
            ip = line.split(' ')[5]
            ip = ip.split('/')[0]
    return ip

# Unix-Shell-Befehl ausführen, Rückgabe als ASCII
def run_cmd(cmd):
    p = Popen(cmd, shell=True, stdout=PIPE)
    output = p.communicate()[0]
    return output.decode('ascii')

# LCD-Bildschirm leeren
lcd.clear()

# bevor wir die Hauptschleife starten - aktives Netzwerkgerät und IP-Adresse erkennen
sleep(2)
interface = find_interface()
ip_address = parse_ip()
count = 0

if __name__ == '__main__':
    try:
        while True:
            if count == 0:
                lcd.cursor_position(7, 0)
                lcd.message = "joy-IT"

                lcd.cursor_position(5, 2)
                lcd.message = "for makers"
                sleep(3)
                lcd.cursor_position(1, 2)
                lcd.message = "& Professionals"
                sleep(3)
                lcd.clear()
                count = 1
                sleep(2)

            lcd.cursor_position(0, 0)
            # Datum und Uhrzeit
            lcd.message = datetime.now().strftime('%b %d  %H:%M:%S\n')

            lcd.cursor_position(0, 3)
	        # aktuelle IP-Adresse
            lcd.message = "IP " + ip_address

            sleep(1)

    except KeyboardInterrupt:
        lcd.clear()
        GPIO.cleanup()